; M712NM.ASM  Telephone number overlay file for MDM712  07/27/83
;
; This file can be edited to make a new library of telephone numbers.
; Each entry must be 34 bytes long and only 26 (A-Z) telephone numbers
; are allowed.  Follow the format for the library entries already in the
; file.  (Be sure to use spaces, not tabs.)
;
; Room has been left if your phone system requires extra characters such
; as:  1-313-846-6127 rather than the 313-846-6127 used in some areas.
;
; This number list is of value even to those not using the PMMI auto-
; dialing system.  If "NUM" is typed while in the command mode, it will
; show the list of stored numbers you can manually dial.  (If the PMMI
; board is used, type "CAL" to initiate an auto-dialed call.  This also
; lists the telephone numbers but in a slightly different format.)  "NUM"
; does not work for PMMI, and "CAL" does not work for non-PMMI.
;
; NOTE: 'R' at the end of a number indicates a ringback system.
;
;
;       TO USE: First edit this file filling in answers for your own
;               equipment.  Then assemble with ASM.COM or equivalent
;               assembler.  Then use 'DDT' to overlay the the results
;               of this program to the original .COM file:
;
;               A>DDT MDM712.COM
;               DDT VERS 2.2
;               NEXT  PC
;               4300 0100
;               -IM712NM.HEX            (note the "I" command)
;               -R                      ("R" loads in the .HEX file)
;               NEXT  PC
;               4300 0000
;               -G0                     (return to CP/M)
;               A>SAVE 66 MDM712.COM    (now have a modified .COM file)
;
;
; NOTE: For those revising the main program, check the location of
;          NUMBLIB to see if the ORG value used here is correct.  If
;          not, change as needed.
;
; =   =   =   =   =   =   =   =   =   =   =   =   =   =   =   =   =   =
;
; 07/27/83  Updated for MDM712          - Irv Hoff
;           Added 'MCI' and/or 'SPRINT'
; 07/01/83  Updated for MDM711          - Irv Hoff
; 06/22/83  Updated for MDM710          - Irv Hoff
; 05/27/83  Updated for MDM709          - Irv Hoff
; 05/15/83  Updated for MDM708          - Irv Hoff
; 04/17/83  Updated for MDM707          - Irv Hoff
; 04/04/83  Updated for MDM706          - Irv Hoff
; 02/27/83  Updated for MDM705          - Irv Hoff
; 02/17/83  Updated for MDM704          - Irv Hoff
; 02/07/82  Updated for MDM703          - Irv Hoff
; 01/27/83  Updated for MDM702          - Irv Hoff
; 01/10/83  Updated for MDM701          - Irv Hoff
;
; =   =   =   =   =   =   =   =   =   =   =   =   =   =   =   =   =   =
;
;
          ORG   0C00H-48
;
;
; Long distance alternate dialing such as MCI, SPRINT, etc.  Must end
; with a '$', use as many commas (2 seconds delay, each) as needed to
; let the alternate dialing code return with a new dial tone.  Fill in
; any character (periods are fine) after the $ to keep number of columns
; to 24, i.e.,  '1234567,,,,12345,,$.....'   --   the first group is the
; MCI or SPRINT access number, the second group is the user number. (A
; small delay is usually required after the user number also.)
;
ALTDIAL1: DB    'xxxxxxx,,,,,,xxxxxxxx,,$'   ;accessed by a < character
;
ALTDIAL2: DB    'xxxxxxx,,,,,,xxxxxxxx,,$'   ;accessed by a > character
;
;
; Phone number library table for auto-dialing.  Each number must be as
; long as "LIBLEN" (EQU at start of program).  Some areas require extra
; characters such as:   1-313-846-7127.  Room is left for those.  Use
; a (<) for alternate dialing system #1, and a (>) for alternate dialing
; system #2.  Either would preceed the acutal number.  For example:
;
;         DB    'A=Alan Alda..........<123-456-7890'    ;'A'
;
; -     -     -     -     -     -     -     -     -     -     -     -
;
;
;               '----5---10---15---20---25---30--34'
NUMBLIB:  DB    'A=Al Mehr (PNET) .... 408-238-9621'    ;'A'
          DB    'B=Byron McKay (PNET) .... 965-4097'    ;'B'
          DB    'C=CompuServe ............ 591-5591'    ;'C'
          DB    'D= ...............................'    ;'D'
          DB    'E= ...............................'    ;'E'
          DB    'F= ...............................'    ;'F'
          DB    'G= ...............................'    ;'G'
          DB    'H= ...............................'    ;'H'
          DB    'I= ...............................'    ;'I'
          DB    'J= ...............................'    ;'J'
          DB    'K= ...............................'    ;'K'
          DB    'L= ...............................'    ;'L'
          DB    'M= Marin BBS ............ 383-0473'    ;'M'
          DB    'N= ...............................'    ;'N'
          DB    'O= ...............................'    ;'O'
          DB    'P= ...............................'    ;'P'
          DB    'Q= ...............................'    ;'Q'
          DB    'R= ...............................'    ;'R'
          DB    'S= ...............................'    ;'S'
          DB    'T= Telenet .............. 856-9995'    ;'T'
          DB    'U= ...............................'    ;'U'
          DB    'V= ...............................'    ;'V'
          DB    'W= ...............................'    ;'W'
          DB    'X= ...............................'    ;'X'
          DB    'Y= ...............................'    ;'Y'
          DB    'Z= ...............................'    ;'Z'
;               '----5---10---15---20---25---30--34'
;
          END
;
 '----5---10---15---20---25---30--34'
;
          END
;

 '----5---10---15---20---25---30--34'
;
          END
;

 